Debian Bug report logs - #648936
liblocale-gettext-perl: Upgrade failure when invoked via dpkg doc-base trigger

version graph

Package: doc-base; Maintainer for doc-base is Robert Luberda <robert@debian.org>; Source for doc-base is src:doc-base.

Reported by: Roger Leigh <rleigh@debian.org>

Date: Wed, 16 Nov 2011 09:33:02 UTC

Severity: serious

Merged with 648937

Found in versions 0.2, doc-base/0.10.2

Fixed in version doc-base/0.10.3

Done: Robert Luberda <robert@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#648936; Package liblocale-gettext-perl. (Wed, 16 Nov 2011 09:33:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Wed, 16 Nov 2011 09:33:09 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: liblocale-gettext-perl: Upgrade failure when invoked via dpkg doc-base trigger
Date: Wed, 16 Nov 2011 09:31:39 +0000
Package: liblocale-gettext-perl
Version: 1.05-7+b1
Severity: serious
Justification: Causes dist-upgrade to abort

Preparing to replace perl-base 5.12.4-6 (using .../perl-base_5.14.2-3_amd64.deb) ...
Unpacking replacement perl-base ...
Processing triggers for man-db ...
Processing triggers for doc-base ...
/usr/bin/perl: symbol lookup error: /usr/lib/perl5/auto/Locale/gettext/gettext.so: undefined symbol: Perl_Gthr_key_ptr
dpkg: error processing doc-base (--unpack):
 subprocess installed post-installation script returned error exit status 127
configured to not write apport reports
                                      Errors were encountered while processing:
 doc-base
E: Sub-process /usr/bin/dpkg returned an error code (1)

Most likely due to the current perl 5.12 → 5.14 transition.  Is a
pre-depends required here in order to not break dpkg triggers for
a wheezy upgrade?  This might require reassigning to the perl-base
package if that's where the problem lies.


Regards,
Roger

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (550, 'unstable'), (500, 'testing'), (400, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 3.0.0-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages liblocale-gettext-perl depends on:
ii  libc6                       2.13-21 
ii  perl-base [perlapi-5.14.2]  5.14.2-3

liblocale-gettext-perl recommends no packages.

liblocale-gettext-perl suggests no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#648936; Package liblocale-gettext-perl. (Wed, 16 Nov 2011 09:57:28 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominic Hargreaves <dom@earth.li>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Wed, 16 Nov 2011 09:57:32 GMT) Full text and rfc822 format available.

Message #10 received at 648936@bugs.debian.org (full text, mbox):

From: Dominic Hargreaves <dom@earth.li>
To: Raphaël Hertzog <hertzog@debian.org>, 648937@bugs.debian.org, 648936@bugs.debian.org, Roger Leigh <rleigh@debian.org>
Subject: Re: Bug#648937: doc-base: trigger fails when Locale::gettext is broken due to perl upgrade
Date: Wed, 16 Nov 2011 09:52:58 +0000
On Wed, Nov 16, 2011 at 10:33:45AM +0100, Raphaël Hertzog wrote:
> Package: doc-base
> Version: 0.10.2
> Severity: serious
> 
> Sorry I only have the log in French but you can translate:
> - Préparation du remplacement -> Preparing to replace
> - Dépaquetage de la mise à jour -> Unpacking update
> - Paramétrage -> Configuring
> - Traitement des actions différées pour -> Processing trigger for
> 
> Préparation du remplacement de perl-doc 5.12.4-6 (en utilisant .../perl-doc_5.14.2-3_all.deb) ...
> Conservation de « détournement de /usr/bin/perldoc en /usr/bin/perldoc.stub par perl-doc »
> Dépaquetage de la mise à jour de perl-doc ...
> Préparation du remplacement de libdevel-cover-perl 0.77-1+b2 (en utilisant .../libdevel-cover-perl_0.77-1+b3_i386.deb) ...
> Dépaquetage de la mise à jour de libdevel-cover-perl ...
> Préparation du remplacement de perl 5.12.4-6 (en utilisant .../perl_5.14.2-3_i386.deb) ...
> Dépaquetage de la mise à jour de perl ...
> Selecting previously unselected package libperl5.14.
> Dépaquetage de libperl5.14 (à partir de .../libperl5.14_5.14.2-3_i386.deb) ...
> [...]
> Dépaquetage de la mise à jour de perl-base ...
> Paramétrage de perl-base (5.14.2-3) ...
> Traitement des actions différées (« triggers ») pour « menu »...
> Traitement des actions différées (« triggers ») pour « desktop-file-utils »...
> Traitement des actions différées (« triggers ») pour « man-db »...
> Traitement des actions différées (« triggers ») pour « doc-base »...
> /usr/bin/perl: symbol lookup error: /usr/lib/perl5/auto/Locale/gettext/gettext.so: undefined symbol: Perl_Gthr_key_ptr
> dpkg : erreur de traitement de doc-base (--triggers-only) :
>  le sous-processus script post-installation installé a retourné une erreur de sortie d'état 127

This has also been reported as #648936 in liblocale-gettext-perl;
not merging now until we decide what's the best course of action.

-- 
Dominic Hargreaves | http://www.larted.org.uk/~dom/
PGP key 5178E2A5 from the.earth.li (keyserver,web,email)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#648936; Package liblocale-gettext-perl. (Wed, 16 Nov 2011 10:00:27 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Wed, 16 Nov 2011 10:00:30 GMT) Full text and rfc822 format available.

Message #15 received at 648936@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Roger Leigh <rleigh@debian.org>, 648936@bugs.debian.org
Subject: Re: Bug#648936: liblocale-gettext-perl: Upgrade failure when invoked via dpkg doc-base trigger
Date: Wed, 16 Nov 2011 10:57:24 +0100
reassign 648936 doc-base 0.2
forcemerge 648937 648936
affects 648937 liblocale-gettext-perl
thanks

On Wed, 16 Nov 2011, Roger Leigh wrote:
> Preparing to replace perl-base 5.12.4-6 (using .../perl-base_5.14.2-3_amd64.deb) ...
> Unpacking replacement perl-base ...
> Processing triggers for man-db ...
> Processing triggers for doc-base ...
> /usr/bin/perl: symbol lookup error: /usr/lib/perl5/auto/Locale/gettext/gettext.so: undefined symbol: Perl_Gthr_key_ptr
> dpkg: error processing doc-base (--unpack):
>  subprocess installed post-installation script returned error exit status 127
> configured to not write apport reports
>                                       Errors were encountered while processing:
>  doc-base
> E: Sub-process /usr/bin/dpkg returned an error code (1)
> 
> Most likely due to the current perl 5.12 → 5.14 transition.  Is a
> pre-depends required here in order to not break dpkg triggers for
> a wheezy upgrade?  This might require reassigning to the perl-base
> package if that's where the problem lies.

This is not a bug in liblocale-gettext-perl. It bites use every time
that we upgrade to a perl version with an incompatible ABI.

See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=479681 for more
explanation. I just filed the bug against doc-base because one should
not rely on Locale::gettext in maintainer scripts if we want those
maintainer scripts to work during upgrades...

Looking further the maintainer already did the right thing (that's why
liblocale-gettext-perl is also not listed in the Depends field of
doc-base) except it needs the environment variable to disable lazy bind,
otherwise the error is not caught at load time but triggered at run-time.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Pre-order a copy of the Debian Administrator's Handbook and help
liberate it: http://debian-handbook.info/go/ulule-rh/




Bug reassigned from package 'liblocale-gettext-perl' to 'doc-base'. Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Wed, 16 Nov 2011 10:00:43 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions liblocale-gettext-perl/1.05-7. Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Wed, 16 Nov 2011 10:00:43 GMT) Full text and rfc822 format available.

Bug Marked as found in versions 0.2. Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Wed, 16 Nov 2011 10:00:44 GMT) Full text and rfc822 format available.

Forcibly Merged 648936 648937. Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Wed, 16 Nov 2011 10:00:45 GMT) Full text and rfc822 format available.

Added indication that 648936 affects liblocale-gettext-perl Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Wed, 16 Nov 2011 10:00:47 GMT) Full text and rfc822 format available.

Added indication that bug 648936 blocks 648954 Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Wed, 16 Nov 2011 11:15:03 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Robert Luberda <robert@debian.org> to control@bugs.debian.org. (Thu, 17 Nov 2011 07:39:14 GMT) Full text and rfc822 format available.

Bug 648954 cloned as bug 652638. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Mon, 19 Dec 2011 14:42:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Robert Luberda <robert@debian.org>:
Bug#648936; Package doc-base. (Mon, 22 Oct 2012 07:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Robert Luberda <robert@debian.org>. (Mon, 22 Oct 2012 07:54:03 GMT) Full text and rfc822 format available.

Message #36 received at 648936@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Robert Luberda <robert@debian.org>
Cc: 648936@bugs.debian.org
Subject: Re: doc-base: trigger fails when Locale::gettext is broken due to perl upgrade
Date: Mon, 22 Oct 2012 00:49:54 -0700
[Message part 1 (text/plain, inline)]
Hi again,

In January, Jonathan Nieder wrote:
> Robert Luberda wrote:

>>    * debian/postinst: set PERL_DL_NONLAZY=1 not to fail when perl is being
>>      upgraded (closes: #648937).
>>    * install-docs.in:
>>      + show verbose warning message when doc-base is not fully functional;
>
> Do you think it would be appropriate to apply these fixes to squeeze, too?

My feeling is that yes, these would be good changes for squeeze, to
make triggers smoother when upgrading squeeze->wheezy and to make the
lenny->squeeze upgrade smoother for those unfortunate souls who
haven't made the jump yet.  Here's a backport.  Sensible?

  Set PERL_DL_NONLAZY=1 variable in postinst to fix Bug#648937.
  Inform users when doc-base is not fully functional.

 debian/changelog | 10 ++++++++++
 debian/postinst  |  4 ++++
 install-docs.in  | 13 ++++++++++++-
 3 files changed, 26 insertions(+), 1 deletion(-)
[01-Set-PERL_DL_NONLAZY-1-variable-in-postinst-to-fix-Bu.patch (text/plain, attachment)]
[02-Inform-users-when-doc-base-is-not-fully-functional.patch (text/plain, attachment)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 02 Jun 2013 07:50:47 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 07:07:37 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.